\ This is an ANS Forth source file

0 [IF]
Copyright (C) 2003    Ken Staton

This program is part of embedded gForth for the Rabbit2000.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
[THEN]


\ overwrite an existing assembler dictionary
Vocabulary Assembler

\ set search path relative to working dir
fpath= ~+


Create mach-file ," arch/R2K/mach.fs"

1 [IF]
\ debugging: produce a relocation and a symbol table
s" rel-table" r/w create-file throw
Constant fd-relocation-table

\ debuggging: produce a symbol table
s" sym-table" r/w create-file throw
Constant fd-symbol-table
[THEN]

include ./cross.fs               \ include cross-compiler

decimal

has? kernel-size makekernel ( size )
\ create image-header
has? header [IF]
0 A,	\ base address
0 ,	\ checksum
0 ,	\ image size (without tags)
>address ,	\ dict size
has? stack-size ,	\ data stack size
has? fstack-size ,	\ FP stack size
has? rstack-size ,	\ return stack size
has? lstack-size ,	\ locals stack size
0 A,	\ code entry point
0 A,	\ throw entry point
has? stack-size ,	\ unused (possibly tib stack size)
0 ,	\ unused
0 ,	\ data stack base
0 ,	\ fp stack base
0 ,	\ return stack base
0 ,	\ locals stack base
[THEN]

UNLOCK ghost - drop \ ghost must exist because - would be treated as number
LOCK

doc-off
has? prims [IF]
    include ./kernel/aliases.fs             \ include primitive aliases
[ELSE]
    prims-include
    undef-words
    include ./kernel/prim.fs
    all-words  UNLOCK LOCK
[THEN]
doc-on

0 AConstant forthstart

\ include ./kernel/vars.fs                \ variables and other stuff
\ include kernel/version.fs \ is in $(build)/kernel
include ./kernel/kernel.fs              \ load kernel
\ include ./kernel/special.fs             \ special must be last!
\ include ./kernel/errore.fs
include ./kernel/doers.fs
\ has? file [IF]
\ include ./kernel/args.fs
\ include ./kernel/files.fs               \ load file words
\ include ./kernel/paths.fs
\ include ./kernel/require.fs
\ [THEN]

has? compiler [IF]
has? glocals [IF]
include ./kernel/cond.fs                \ load IF and co
[ELSE]
include ./kernel/cond-old.fs            \ load IF and co w/o locals
[THEN]
\ include arch/misc/tt.fs
\ include arch/misc/sokoban.fs
[THEN]
include ./kernel/quotes.fs
include ./kernel/toolsext.fs
include ./kernel/tools.fs               \ load tools ( .s dump )
include ./kernel/getdoers.fs

include ./arch/r2k/marker.fs		\ kls need marker

\ :noname					\ set forget at cold...
\  defers 'cold
\  s" marker forget" evaluate
\ ; IS 'cold

include ./arch/r2k/load-read.fs		\ for no flow control source transfers

: sourcefilename s" nix" ;
: loadfilename# 0 ;
Create tib-line 100 allot

\ Setup                                                13feb93py

has? header [IF]
\    UNLOCK
    here >address 2 cells  !  \ image size
    ' boot >body  8 cells A!  \ Entry point
\    LOCK
[ELSE]
  >boot
[THEN]

include ./kernel/pass.fs

.unresolved

save-cross gfR2K.bin gfR2K.bin
